diff --git a/usr.sbin/mtree/create.c b/usr.sbin/mtree/create.c
index b6c0ab44bc..82427d6c11 100644
--- a/usr.sbin/mtree/create.c
+++ b/usr.sbin/mtree/create.c
@@ -1,3 +1,5 @@
+/*	$NetBSD: create.c,v 1.75 2017/12/31 03:04:44 christos Exp $	*/
+
 /*-
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -25,35 +27,55 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- * @(#)create.c	8.1 (Berkeley) 6/6/93
- * $FreeBSD: src/usr.sbin/mtree/create.c,v 1.18.2.3 2001/01/12 19:17:18 phk Exp $
  */
 
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+#if defined(__RCSID) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)create.c	8.1 (Berkeley) 6/6/93";
+#else
+__RCSID("$NetBSD: create.c,v 1.75 2017/12/31 03:04:44 christos Exp $");
+#endif
+#endif /* not lint */
+
 #include <sys/param.h>
 #include <sys/stat.h>
+
+#if ! HAVE_NBTOOL_CONFIG_H
 #include <dirent.h>
-#include <err.h>
+#endif
+
 #include <errno.h>
 #include <fcntl.h>
-#include <fts.h>
 #include <grp.h>
-#ifdef MD5
+#include <pwd.h>
+#include <stdio.h>
+#include <stdarg.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+
+#ifndef NO_MD5
 #include <md5.h>
 #endif
-#ifdef SHA1
+#ifndef NO_RMD160
+#include <rmd160.h>
+#endif
+#ifndef NO_SHA1
 #include <sha.h>
+#include <sha1hl.h>
 #endif
-#ifdef RMD160
-#include <ripemd.h>
+#ifndef NO_SHA2
+#include <sha256.h>
+#include <sha512.h>
 #endif
-#include <pwd.h>
-#include <stdio.h>
-#include <time.h>
-#include <unistd.h>
-#include <stdarg.h>
-#include <vis.h>
-#include "mtree.h"
+
 #include "extern.h"
 
 #define	INDENTNAMELEN	15
@@ -62,310 +84,360 @@
 static gid_t gid;
 static uid_t uid;
 static mode_t mode;
-static u_long flags = 0xffffffff;
+static u_long flags;
 
-static int	dsort(const FTSENT * const *, const FTSENT * const *);
-static void	output(int, int *, const char *, ...) __printflike(3, 4);
-static int	statd(FTS *, FTSENT *, uid_t *, gid_t *, mode_t *,
-			   u_long *);
-static void	statf(int, FTSENT *);
+#if defined(__FreeBSD__) || defined(__DragonFly__)
+#define	FTS_CONST const
+#else
+#define	FTS_CONST
+#endif
+
+static int	dcmp(const FTSENT *FTS_CONST *, const FTSENT *FTS_CONST *);
+static void	output(FILE *, int, int *, const char *, ...)
+    __printflike(4, 5);
+static int	statd(FILE *, FTS *, FTSENT *, uid_t *, gid_t *, mode_t *,
+    u_long *);
+static void	statf(FILE *, int, FTSENT *);
 
 void
-cwalk(void)
+cwalk(FILE *fp)
 {
 	FTS *t;
 	FTSENT *p;
-	time_t clk;
-	char *argv[2], host[MAXHOSTNAMELEN], dot[] = ".";
+	time_t clocktime;
+	char host[MAXHOSTNAMELEN + 1];
+	const char *user;
+	char *argv[2];
+	char  dot[] = ".";
 	int indent = 0;
 
-	time(&clk);
-	gethostname(host, sizeof(host));
-	printf(
-	    "#\t   user: %s\n#\tmachine: %s\n#\t   tree: %s\n#\t   date: %s",
-	    getlogin(), host, fullpath, ctime(&clk));
-
 	argv[0] = dot;
 	argv[1] = NULL;
-	if ((t = fts_open(argv, ftsoptions, dsort)) == NULL)
-		err(1, "line %d: fts_open", lineno);
-	while ((p = fts_read(t))) {
-		if (iflag)
+
+	time(&clocktime);
+	gethostname(host, sizeof(host));
+	host[sizeof(host) - 1] = '\0';
+	if ((user = getlogin()) == NULL) {
+		struct passwd *pw;
+		user = (pw = getpwuid(getuid())) == NULL ? pw->pw_name :
+		    "<unknown>";
+	}
+
+	if (!nflag)
+		fprintf(fp,
+	    	    "#\t   user: %s\n#\tmachine: %s\n#\t   tree: %s\n"
+		    "#\t   date: %s",
+		    user, host, fullpath, ctime(&clocktime));
+
+	if ((t = fts_open(argv, ftsoptions, dcmp)) == NULL)
+		mtree_err("fts_open: %s", strerror(errno));
+	while ((p = fts_read(t)) != NULL) {
+		if (jflag)
 			indent = p->fts_level * 4;
 		if (check_excludes(p->fts_name, p->fts_path)) {
 			fts_set(t, p, FTS_SKIP);
 			continue;
 		}
+		if (!find_only(p->fts_path)) {
+			fts_set(t, p, FTS_SKIP);
+			continue;
+		}
 		switch(p->fts_info) {
 		case FTS_D:
-			if (!dflag)
-				printf("\n");
+			if (!bflag)
+				fprintf(fp, "\n");
 			if (!nflag)
-				printf("# %s\n", p->fts_path);
-			statd(t, p, &uid, &gid, &mode, &flags);
-			statf(indent, p);
+				fprintf(fp, "# %s\n", p->fts_path);
+			statd(fp, t, p, &uid, &gid, &mode, &flags);
+			statf(fp, indent, p);
 			break;
 		case FTS_DP:
-			if (!nflag && (p->fts_level > 0))
-				printf("%*s# %s\n", indent, "", p->fts_path);
-			printf("%*s..\n", indent, "");
-			if (!dflag)
-				printf("\n");
+			if (p->fts_level > 0)
+				if (!nflag)
+					fprintf(fp, "%*s# %s\n", indent, "",
+					    p->fts_path);
+			if (p->fts_level > 0 || flavor == F_FREEBSD9) {
+				fprintf(fp, "%*s..\n", indent, "");
+				if (!bflag)
+					fprintf(fp, "\n");
+			}
 			break;
 		case FTS_DNR:
 		case FTS_ERR:
 		case FTS_NS:
-			warnx("%s: %s", p->fts_path, strerror(p->fts_errno));
+			mtree_err("%s: %s",
+			    p->fts_path, strerror(p->fts_errno));
 			break;
 		default:
 			if (!dflag)
-				statf(indent, p);
+				statf(fp, indent, p);
 			break;
 
 		}
 	}
 	fts_close(t);
 	if (sflag && keys & F_CKSUM)
-		warnx("%s checksum: %u", fullpath, crc_total);
+		mtree_err("%s checksum: %u", fullpath, crc_total);
 }
 
 static void
-statf(int indent, FTSENT *p)
+dosum(FILE *fp, int indent, FTSENT *p, int *offset, int flag,
+    char * (*func)(const char *, char *), const char *key)
 {
-	struct group *gr;
-	struct passwd *pw;
-	uint32_t val;
-	off_t len;
-	int fd, offset;
-	char *fflags;
-	char *escaped_name;
-
-	escaped_name = calloc(1, p->fts_namelen * 4  +  1);
-	if (escaped_name == NULL)
-		errx(1, "statf(): calloc() failed");
-	strvis(escaped_name, p->fts_name, VIS_WHITE | VIS_OCTAL);
-
-	if (iflag || S_ISDIR(p->fts_statp->st_mode))
-		offset = printf("%*s%s", indent, "", escaped_name);
-	else
-		offset = printf("%*s    %s", indent, "", escaped_name);
-	
-	free(escaped_name);
+	char *digestbuf;
+
+	if ((keys & flag) == 0)
+		return;
+
+	digestbuf = (*func)(p->fts_accpath, NULL);
+	if (digestbuf != NULL) {
+		output(fp, indent, offset, "%s=%s", key, digestbuf);
+		free(digestbuf);
+		return;
+	}
+
+	if (qflag) {
+		warn("%s: %s failed", p->fts_path, key);
+		return;
+	}
+
+	mtree_err("%s: %s failed: %s", p->fts_path, key, strerror(errno));
+}
+
+static char *
+crcFile(const char *fname, char *dummy __unused)
+{
+	char *ptr;
+	uint32_t val, len;
+	int fd, e;
+
+	if ((fd = open(fname, O_RDONLY)) == -1)
+		goto out;
+
+	e = crc(fd, &val, &len);
+	close(fd);
+	if (e)
+		goto out;
+
+	if (asprintf(&ptr, "%u", val) < 0)
+		goto out;
+
+	return ptr;
+out:
+	mtree_err("%s: %s", fname, strerror(errno));
+	return NULL;
+}
+
+static void
+statf(FILE *fp, int indent, FTSENT *p)
+{
+	int offset;
+	const char *name = NULL;
+
+	offset = fprintf(fp, "%*s%s%s", indent, "",
+	    S_ISDIR(p->fts_statp->st_mode) ? "" : "    ", vispath(p->fts_name));
 
 	if (offset > (INDENTNAMELEN + indent))
 		offset = MAXLINELEN;
 	else
-		offset += printf("%*s", (INDENTNAMELEN + indent) - offset, "");
-
-	if (!S_ISREG(p->fts_statp->st_mode) && !dflag)
-		output(indent, &offset, "type=%s", inotype(p->fts_statp->st_mode));
-	if (p->fts_statp->st_uid != uid) {
-		if (keys & F_UNAME) {
-			if ((pw = getpwuid(p->fts_statp->st_uid)) != NULL) {
-				output(indent, &offset, "uname=%s", pw->pw_name);
-			} else {
-				errx(1,
-				"line %d: could not get uname for uid=%u",
-				lineno, p->fts_statp->st_uid);
-			}
-		}
-		if (keys & F_UID)
-			output(indent, &offset, "uid=%u", p->fts_statp->st_uid);
+		offset += fprintf(fp, "%*s",
+		    (INDENTNAMELEN + indent) - offset, "");
+
+	if (!S_ISREG(p->fts_statp->st_mode) && (flavor == F_NETBSD6 || !dflag))
+		output(fp, indent, &offset, "type=%s",
+		    inotype(p->fts_statp->st_mode));
+	if (keys & (F_UID | F_UNAME) && p->fts_statp->st_uid != uid) {
+		if (keys & F_UNAME &&
+		    (name = user_from_uid(p->fts_statp->st_uid, 1)) != NULL)
+			output(fp, indent, &offset, "uname=%s", name);
+		if (keys & F_UID || (keys & F_UNAME && name == NULL))
+			output(fp, indent, &offset, "uid=%u",
+			    p->fts_statp->st_uid);
 	}
-	if (p->fts_statp->st_gid != gid) {
-		if (keys & F_GNAME) {
-			if ((gr = getgrgid(p->fts_statp->st_gid)) != NULL) {
-				output(indent, &offset, "gname=%s", gr->gr_name);
-			} else {
-				errx(1,
-				"line %d: could not get gname for gid=%u",
-				lineno, p->fts_statp->st_gid);
-			}
-		}
-		if (keys & F_GID)
-			output(indent, &offset, "gid=%u", p->fts_statp->st_gid);
+	if (keys & (F_GID | F_GNAME) && p->fts_statp->st_gid != gid) {
+		if (keys & F_GNAME &&
+		    (name = group_from_gid(p->fts_statp->st_gid, 1)) != NULL)
+			output(fp, indent, &offset, "gname=%s", name);
+		if (keys & F_GID || (keys & F_GNAME && name == NULL))
+			output(fp, indent, &offset, "gid=%u",
+			    p->fts_statp->st_gid);
 	}
 	if (keys & F_MODE && (p->fts_statp->st_mode & MBITS) != mode)
-		output(indent, &offset, "mode=%#o", p->fts_statp->st_mode & MBITS);
+		output(fp, indent, &offset, "mode=%#o",
+		    p->fts_statp->st_mode & MBITS);
+	if (keys & F_DEV &&
+	    (S_ISBLK(p->fts_statp->st_mode) || S_ISCHR(p->fts_statp->st_mode)))
+		output(fp, indent, &offset, "device=%#jx",
+		    (uintmax_t)p->fts_statp->st_rdev);
 	if (keys & F_NLINK && p->fts_statp->st_nlink != 1)
-		output(indent, &offset, "nlink=%u", p->fts_statp->st_nlink);
-	if (keys & F_SIZE)
-		output(indent, &offset, "size=%jd",
+		output(fp, indent, &offset, "nlink=%ju",
+		    (uintmax_t)p->fts_statp->st_nlink);
+	if (keys & F_SIZE &&
+	    (flavor == F_FREEBSD9 || S_ISREG(p->fts_statp->st_mode)))
+		output(fp, indent, &offset, "size=%ju",
 		    (uintmax_t)p->fts_statp->st_size);
 	if (keys & F_TIME)
-		output(indent, &offset, "time=%ld.%ld",
-		    p->fts_statp->st_mtimespec.tv_sec,
+#if defined(BSD4_4) && !defined(HAVE_NBTOOL_CONFIG_H)
+		output(fp, indent, &offset, "time=%jd.%09ld",
+		    (intmax_t)p->fts_statp->st_mtimespec.tv_sec,
 		    p->fts_statp->st_mtimespec.tv_nsec);
-	if (keys & F_CKSUM && S_ISREG(p->fts_statp->st_mode)) {
-		if ((fd = open(p->fts_accpath, O_RDONLY, 0)) < 0 ||
-		    crc(fd, &val, &len))
-			err(1, "line %d: %s", lineno, p->fts_accpath);
-		close(fd);
-		output(indent, &offset, "cksum=%u", val);
-	}
-#ifdef MD5
-	if (keys & F_MD5 && S_ISREG(p->fts_statp->st_mode)) {
-		char *digest, buf[33];
-
-		digest = MD5File(p->fts_accpath, buf);
-		if (!digest) {
-			err(1, "line %d: %s", lineno, p->fts_accpath);
-		} else {
-			output(indent, &offset, "md5digest=%s", digest);
-		}
-	}
-#endif /* MD5 */
-#ifdef SHA1
-	if (keys & F_SHA1 && S_ISREG(p->fts_statp->st_mode)) {
-		char *digest, buf[41];
-
-		digest = SHA1_File(p->fts_accpath, buf);
-		if (!digest) {
-			err(1, "line %d: %s", lineno, p->fts_accpath);
-		} else {
-			output(indent, &offset, "sha1digest=%s", digest);
-		}
-	}
-#endif /* SHA1 */
-#ifdef RMD160
-	if (keys & F_RMD160 && S_ISREG(p->fts_statp->st_mode)) {
-		char *digest, buf[41];
-
-		digest = RIPEMD160_File(p->fts_accpath, buf);
-		if (!digest) {
-			err(1, "line %d: %s", lineno, p->fts_accpath);
-		} else {
-			output(indent, &offset, "ripemd160digest=%s", digest);
-		}
+#else
+		output(fp, indent, &offset, "time=%jd.%09ld",
+		    (intmax_t)p->fts_statp->st_mtime, (long)0);
+#endif
+	if (S_ISREG(p->fts_statp->st_mode))  {
+		dosum(fp, indent, p, &offset, F_CKSUM, crcFile, "cksum");
+#ifndef NO_MD5
+		dosum(fp, indent, p, &offset, F_MD5, MD5File, MD5KEY);
+#endif	/* ! NO_MD5 */
+#ifndef NO_RMD160
+		dosum(fp, indent, p, &offset, F_RMD160, RMD160File, RMD160KEY);
+#endif	/* ! NO_RMD160 */
+#ifndef NO_SHA1
+		dosum(fp, indent, p, &offset, F_SHA1, SHA1_File, SHA1KEY);
+#endif	/* ! NO_SHA1 */
+#ifndef NO_SHA2
+		dosum(fp, indent, p, &offset, F_SHA256, SHA256_File, SHA256KEY);
+#if 0 /* XXX DragonFly */
+#ifdef SHA384_BLOCK_LENGTH
+		dosum(fp, indent, p, &offset, F_SHA384, SHA384_File, SHA384KEY);
+#endif
+#endif
+		dosum(fp, indent, p, &offset, F_SHA512, SHA512_File, SHA512KEY);
+#endif	/* ! NO_SHA2 */
 	}
-#endif /* RMD160 */
 	if (keys & F_SLINK &&
 	    (p->fts_info == FTS_SL || p->fts_info == FTS_SLNONE))
-		output(indent, &offset, "link=%s", rlink(p->fts_accpath));
+		output(fp, indent, &offset, "link=%s",
+		    vispath(rlink(p->fts_accpath)));
+#if HAVE_STRUCT_STAT_ST_FLAGS
 	if (keys & F_FLAGS && p->fts_statp->st_flags != flags) {
-		fflags = flags_to_string(p->fts_statp->st_flags);
-		output(indent, &offset, "flags=%s", fflags);
-		free(fflags);
+		char *str = flags_to_string(p->fts_statp->st_flags, "none");
+		output(fp, indent, &offset, "flags=%s", str);
+		free(str);
 	}
+#endif
 	putchar('\n');
 }
 
-#define	MAXGID	5000
-#define	MAXUID	5000
-#define	MAXMODE	MBITS + 1
-#define	MAXFLAGS 256
-#define	MAXS 16
+/* XXX
+ * FLAGS2INDEX will fail once the user and system settable bits need more
+ * than one byte, respectively.
+ */
+#define FLAGS2INDEX(x)  (((x >> 8) & 0x0000ff00) | (x & 0x000000ff))
+
+#define	MTREE_MAXGID	5000
+#define	MTREE_MAXUID	5000
+#define	MTREE_MAXMODE	(MBITS + 1)
+#if HAVE_STRUCT_STAT_ST_FLAGS
+#define	MTREE_MAXFLAGS  (FLAGS2INDEX(CH_MASK) + 1)   /* 1808 */
+#else
+#define MTREE_MAXFLAGS	1
+#endif
+#define	MTREE_MAXS 16
 
 static int
-statd(FTS *t, FTSENT *parent, uid_t *puid, gid_t *pgid, mode_t *pmode,
-      u_long *pflags)
+statd(FILE *fp, FTS *t, FTSENT *parent, uid_t *puid, gid_t *pgid, mode_t *pmode,
+    u_long *pflags)
 {
 	FTSENT *p;
 	gid_t sgid;
 	uid_t suid;
 	mode_t smode;
-	u_long sflags;
-	struct group *gr;
-	struct passwd *pw;
-	gid_t savegid = *pgid;
-	uid_t saveuid = *puid;
-	mode_t savemode = *pmode;
-	u_long saveflags = *pflags;
+	u_long sflags = 0;
+	const char *name = NULL;
+	gid_t savegid;
+	uid_t saveuid;
+	mode_t savemode;
+	u_long saveflags;
 	u_short maxgid, maxuid, maxmode, maxflags;
-	u_short g[MAXGID], u[MAXUID], m[MAXMODE], f[MAXFLAGS];
-	char *fflags;
+	u_short g[MTREE_MAXGID], u[MTREE_MAXUID],
+		m[MTREE_MAXMODE], f[MTREE_MAXFLAGS];
 	static int first = 1;
 
+	savegid = *pgid;
+	saveuid = *puid;
+	savemode = *pmode;
+	saveflags = *pflags;
 	if ((p = fts_children(t, 0)) == NULL) {
 		if (errno)
-			err(1, "line %d: %s", lineno, RP(parent));
+			mtree_err("%s: %s", RP(parent), strerror(errno));
 		return (1);
 	}
 
-	bzero(g, sizeof(g));
-	bzero(u, sizeof(u));
-	bzero(m, sizeof(m));
-	bzero(f, sizeof(f));
+	memset(g, 0, sizeof(g));
+	memset(u, 0, sizeof(u));
+	memset(m, 0, sizeof(m));
+	memset(f, 0, sizeof(f));
 
 	maxuid = maxgid = maxmode = maxflags = 0;
 	for (; p; p = p->fts_link) {
-		if (!dflag || (dflag && S_ISDIR(p->fts_statp->st_mode))) {
+		if (flavor == F_NETBSD6 || !dflag ||
+		    (dflag && S_ISDIR(p->fts_statp->st_mode))) {
 			smode = p->fts_statp->st_mode & MBITS;
-			if (smode < MAXMODE && ++m[smode] > maxmode) {
+			if (smode < MTREE_MAXMODE && ++m[smode] > maxmode) {
 				savemode = smode;
 				maxmode = m[smode];
 			}
 			sgid = p->fts_statp->st_gid;
-			if (sgid < MAXGID && ++g[sgid] > maxgid) {
+			if (sgid < MTREE_MAXGID && ++g[sgid] > maxgid) {
 				savegid = sgid;
 				maxgid = g[sgid];
 			}
 			suid = p->fts_statp->st_uid;
-			if (suid < MAXUID && ++u[suid] > maxuid) {
+			if (suid < MTREE_MAXUID && ++u[suid] > maxuid) {
 				saveuid = suid;
 				maxuid = u[suid];
 			}
 
-			/*
-			 * XXX
-			 * note that the below will break when file flags
-			 * are extended beyond the first 4 bytes of each
-			 * half word of the flags
-			 */
-#define FLAGS2IDX(f) ((f & 0xf) | ((f >> 12) & 0xf0))
-			sflags = p->fts_statp->st_flags;
-			if (FLAGS2IDX(sflags) < MAXFLAGS &&
-			    ++f[FLAGS2IDX(sflags)] > maxflags) {
-				saveflags = sflags;
-				maxflags = f[FLAGS2IDX(sflags)];
+#if HAVE_STRUCT_STAT_ST_FLAGS
+			sflags = FLAGS2INDEX(p->fts_statp->st_flags);
+			if (sflags < MTREE_MAXFLAGS && ++f[sflags] > maxflags) {
+				saveflags = p->fts_statp->st_flags;
+				maxflags = f[sflags];
 			}
+#endif
 		}
 	}
 	/*
-	 * If the /set record is the same as the last one we do not need to output
-	 * a new one.  So first we check to see if anything changed.  Note that we
-	 * always output a /set record for the first directory.
+	 * If the /set record is the same as the last one we do not need to
+	 * output a new one.  So first we check to see if anything changed.
+	 * Note that we always output a /set record for the first directory.
 	 */
-	if ((((keys & F_UNAME) | (keys & F_UID)) && (*puid != saveuid)) ||
-	    (((keys & F_GNAME) | (keys & F_GID)) && (*pgid != savegid)) ||
+	if (((keys & (F_UNAME | F_UID)) && (*puid != saveuid)) ||
+	    ((keys & (F_GNAME | F_GID)) && (*pgid != savegid)) ||
 	    ((keys & F_MODE) && (*pmode != savemode)) || 
 	    ((keys & F_FLAGS) && (*pflags != saveflags)) ||
-	    (first)) {
+	    first) {
 		first = 0;
-		if (dflag)
-			printf("/set type=dir");
+		if (flavor != F_NETBSD6 && dflag)
+			fprintf(fp, "/set type=dir");
 		else
-			printf("/set type=file");
-		if (keys & F_UNAME) {
-			if ((pw = getpwuid(saveuid)) != NULL)
-				printf(" uname=%s", pw->pw_name);
-			else
-				errx(1,
-				"line %d: could not get uname for uid=%u",
-				lineno, saveuid);
+			fprintf(fp, "/set type=file");
+		if (keys & (F_UID | F_UNAME)) {
+			if (keys & F_UNAME &&
+			    (name = user_from_uid(saveuid, 1)) != NULL)
+				fprintf(fp, " uname=%s", name);
+			if (keys & F_UID || (keys & F_UNAME && name == NULL))
+				fprintf(fp, " uid=%lu", (u_long)saveuid);
 		}
-		if (keys & F_UID)
-			printf(" uid=%lu", (u_long)saveuid);
-		if (keys & F_GNAME) {
-			if ((gr = getgrgid(savegid)) != NULL)
-				printf(" gname=%s", gr->gr_name);
-			else
-				errx(1,
-				"line %d: could not get gname for gid=%u",
-				lineno, savegid);
+		if (keys & (F_GID | F_GNAME)) {
+			if (keys & F_GNAME &&
+			    (name = group_from_gid(savegid, 1)) != NULL)
+				fprintf(fp, " gname=%s", name);
+			if (keys & F_GID || (keys & F_GNAME && name == NULL))
+				fprintf(fp, " gid=%lu", (u_long)savegid);
 		}
-		if (keys & F_GID)
-			printf(" gid=%lu", (u_long)savegid);
 		if (keys & F_MODE)
-			printf(" mode=%#o", savemode);
+			fprintf(fp, " mode=%#lo", (u_long)savemode);
 		if (keys & F_NLINK)
-			printf(" nlink=1");
+			fprintf(fp, " nlink=1");
 		if (keys & F_FLAGS) {
-			fflags = flags_to_string(saveflags);
-			printf(" flags=%s", fflags);
-			free(fflags);
+			char *str = flags_to_string(saveflags, "none");
+			fprintf(fp, " flags=%s", str);
+			free(str);
 		}
-		printf("\n");
+		fprintf(fp, "\n");
 		*puid = saveuid;
 		*pgid = savegid;
 		*pmode = savemode;
@@ -374,8 +446,17 @@ statd(FTS *t, FTSENT *parent, uid_t *puid, gid_t *pgid, mode_t *pmode,
 	return (0);
 }
 
+/*
+ * dcmp --
+ *	used as a comparison function passed to fts_open() to control
+ *	the order in which fts_read() returns results.	We make
+ *	directories sort after non-directories, but otherwise sort in
+ *	strcmp() order.
+ *
+ * Keep this in sync with nodecmp() in spec.c.
+ */
 static int
-dsort(const FTSENT * const *a, const FTSENT * const *b)
+dcmp(const FTSENT *FTS_CONST *a, const FTSENT *FTS_CONST *b)
 {
 
 	if (S_ISDIR((*a)->fts_statp->st_mode)) {
@@ -387,7 +468,7 @@ dsort(const FTSENT * const *a, const FTSENT * const *b)
 }
 
 void
-output(int indent, int *offset, const char *fmt, ...)
+output(FILE *fp, int indent, int *offset, const char *fmt, ...)
 {
 	va_list ap;
 	char buf[1024];
@@ -397,8 +478,8 @@ output(int indent, int *offset, const char *fmt, ...)
 	va_end(ap);
 
 	if (*offset + strlen(buf) > MAXLINELEN - 3) {
-		printf(" \\\n%*s", INDENTNAMELEN + indent, "");
+		fprintf(fp, " \\\n%*s", INDENTNAMELEN + indent, "");
 		*offset = INDENTNAMELEN + indent;
 	}
-	*offset += printf(" %s", buf) + 1;
+	*offset += fprintf(fp, " %s", buf) + 1;
 }
diff --git a/usr.sbin/mtree/excludes.c b/usr.sbin/mtree/excludes.c
index ffcf3c32fa..4b46b89092 100644
--- a/usr.sbin/mtree/excludes.c
+++ b/usr.sbin/mtree/excludes.c
@@ -1,3 +1,5 @@
+/*	$NetBSD: excludes.c,v 1.13 2004/06/20 22:20:18 jmc Exp $	*/
+
 /*
  * Copyright 2000 Massachusetts Institute of Technology
  *
@@ -12,7 +14,7 @@
  * no representations about the suitability of this software for any
  * purpose.  It is provided "as is" without express or implied
  * warranty.
- * 
+ *
  * THIS SOFTWARE IS PROVIDED BY M.I.T. ``AS IS''.  M.I.T. DISCLAIMS
  * ALL EXPRESS OR IMPLIED WARRANTIES WITH REGARD TO THIS SOFTWARE,
  * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
@@ -25,25 +27,33 @@
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- * $FreeBSD: src/usr.sbin/mtree/excludes.c,v 1.1.2.4 2001/01/12 19:17:18 phk Exp $
  */
 
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+
+#if defined(__RCSID) && !defined(lint)
+__RCSID("$NetBSD: excludes.c,v 1.13 2004/06/20 22:20:18 jmc Exp $");
+#endif
+
 #include <sys/types.h>
-#include <sys/time.h>		/* XXX for mtree.h */
 #include <sys/queue.h>
 
-#include <err.h>
 #include <fnmatch.h>
-#include <fts.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
+#include <time.h>
+#include <util.h>
 
-#include "mtree.h"		/* XXX for extern.h */
 #include "extern.h"
 
+
 /*
- * We're assuming that there won't be a whole lot of excludes, 
+ * We're assuming that there won't be a whole lot of excludes,
  * so it's OK to use a stupid algorithm.
  */
 struct exclude {
@@ -53,6 +63,7 @@ struct exclude {
 };
 static LIST_HEAD(, exclude) excludes;
 
+
 void
 init_excludes(void)
 {
@@ -64,28 +75,24 @@ void
 read_excludes_file(const char *name)
 {
 	FILE *fp;
-	char *line, *str;
+	char *line;
 	struct exclude *e;
-	size_t len;
 
 	fp = fopen(name, "r");
-	if (fp == NULL)
+	if (fp == 0)
 		err(1, "%s", name);
 
-	while ((line = fgetln(fp, &len)) != NULL) {
-		if (line[len - 1] == '\n')
-			len--;
-		if (len == 0)
+	while ((line = fparseln(fp, NULL, NULL, NULL,
+	    FPARSELN_UNESCCOMM | FPARSELN_UNESCCONT | FPARSELN_UNESCESC))
+	    != NULL) {
+		if (line[0] == '\0')
 			continue;
 
-		str = malloc(len + 1);
-		e = malloc(sizeof *e);
-		if (str == NULL || e == NULL)
-			errx(1, "memory allocation error");
-		e->glob = str;
-		memcpy(str, line, len);
-		str[len] = '\0';
-		if (strchr(str, '/'))
+		if ((e = malloc(sizeof *e)) == NULL)
+			mtree_err("memory allocation error");
+
+		e->glob = line;
+		if (strchr(e->glob, '/') != NULL)
 			e->pathname = 1;
 		else
 			e->pathname = 0;
@@ -102,10 +109,13 @@ check_excludes(const char *fname, const char *path)
 	/* fnmatch(3) has a funny return value convention... */
 #define MATCH(g, n) (fnmatch((g), (n), FNM_PATHNAME) == 0)
 
-	LIST_FOREACH(e, &excludes, link) {
-		if ((e->pathname && MATCH(e->glob, path)) ||
-		    MATCH(e->glob, fname))
-			return 1;
+	e = LIST_FIRST(&excludes);
+	while (e) {
+		if ((e->pathname && MATCH(e->glob, path))
+		    || MATCH(e->glob, fname)) {
+			return (1);
+		}
+		e = LIST_NEXT(e, link);
 	}
-	return 0;
+	return (0);
 }
diff --git a/usr.sbin/mtree/extern.h b/usr.sbin/mtree/extern.h
index 40b5fabcfb..78feacbafa 100644
--- a/usr.sbin/mtree/extern.h
+++ b/usr.sbin/mtree/extern.h
@@ -1,3 +1,5 @@
+/*	$NetBSD: extern.h,v 1.39 2014/04/24 17:22:41 christos Exp $	*/
+
 /*-
  * Copyright (c) 1991, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -27,29 +29,65 @@
  * SUCH DAMAGE.
  *
  *	@(#)extern.h	8.1 (Berkeley) 6/6/93
- * $FreeBSD: src/usr.sbin/mtree/extern.h,v 1.3.2.2 2000/06/28 02:33:17 joe Exp $
  */
 
-#ifdef MAXPATHLEN
-extern char fullpath[MAXPATHLEN];
+#include "mtree.h"
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#else 
+#define HAVE_STRUCT_STAT_ST_FLAGS 1
 #endif
-extern int dflag, eflag, iflag, nflag, qflag, rflag, sflag, uflag;
-extern int ftsoptions;
-extern int lineno;
-extern uint32_t crc_total;
-extern u_int keys;
+ 
+#include <err.h> 
+#include <fts.h>
+#include <libutil.h>
+#include <stdbool.h>
 
-int	 compare(NODE *, FTSENT *);
-int	 crc(int, uint32_t *, off_t *);
-void	 cwalk(void);
-char	*flags_to_string(u_long);
+#if HAVE_NETDB_H
+/* For MAXHOSTNAMELEN on some platforms. */
+#include <netdb.h>
+#endif
+
+#ifndef MAXHOSTNAMELEN
+#define MAXHOSTNAMELEN 256
+#endif
 
-const char *inotype(u_int);
-u_int	 parsekey(char *, int *);
-char	*rlink(char *);
-NODE	*spec(void);
-int	 verify(void);
+enum flavor {
+	F_MTREE,
+	F_FREEBSD9,
+	F_NETBSD6
+};
 
+void	 addtag(slist_t *, char *);
 int	 check_excludes(const char *, const char *);
+int	 compare(NODE *, FTSENT *);
+int	 crc(int, u_int32_t *, u_int32_t *);
+void	 cwalk(FILE *);
+void	 dump_nodes(FILE *, const char *, NODE *, int);
 void	 init_excludes(void);
+int	 matchtags(NODE *);
+__dead2 __printflike(1,2) void	 mtree_err(const char *, ...);
+const char *nodetype(u_int);
+u_int	 parsekey(const char *, int *);
+void	 parsetags(slist_t *, char *);
+u_int	 parsetype(const char *);
 void	 read_excludes_file(const char *);
+const char *rlink(const char *);
+int	 verify(FILE *);
+void	 load_only(const char *fname);
+bool	 find_only(const char *path);
+
+char	*flags_to_string(unsigned long, const char *);
+int	 string_to_flags(char **, unsigned long *, unsigned long *);
+
+extern int	bflag, dflag, eflag, iflag, jflag, lflag, mflag,
+		nflag, qflag, rflag, sflag, tflag, uflag;
+extern int	mtree_Mflag, mtree_Sflag, mtree_Wflag;
+extern size_t	mtree_lineno;
+extern enum flavor	flavor;
+extern u_int32_t crc_total;
+extern int	ftsoptions, keys;
+extern char	fullpath[];
+extern slist_t	includetags, excludetags;
+
